unit UnidadMenuPrincipal;

{$R WinXP.res}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, NMFtp, ExtCtrls,
  registry, inifiles, Buttons, VCLUnZip, Menus, Psock, shellapi, ThemeMgr,
  aes, base64, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdFTP;

type
  TformMenuPrincipal = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    txtServidor: TEdit;
    txtUsuario: TEdit;
    Label2: TLabel;
    txtContrasena: TEdit;
    Label3: TLabel;
    GroupBox2: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    txtCarpeta1: TEdit;
    txtCarpeta2: TEdit;
    txtCarpeta3: TEdit;
    Label7: TLabel;
    txtCarpeta4: TEdit;
    Label8: TLabel;
    txtFichero: TEdit;
    txtFicheroLocal: TEdit;
    Label9: TLabel;
    Panel1: TPanel;
    zDescom: TVCLUnZip;
    GroupBox4: TGroupBox;
    lEstado: TLabel;
    BComprobar: TBitBtn;
    BActualizar: TBitBtn;
    BDesconectar: TBitBtn;
    BCerrar: TBitBtn;
    LWEB: TLabel;
    opDetalle: TCheckBox;
    btOpciones: TBitBtn;
    ThemeManager1: TThemeManager;
    Label14: TLabel;
    txtPuerto: TEdit;
    GroupBox5: TGroupBox;
    Label15: TLabel;
    Label16: TLabel;
    txtNombreAplicacion: TEdit;
    txtVersion: TEdit;
    txtClaveRegistro: TEdit;
    Label17: TLabel;
    ftpDes: TIdFTP;
    bp: TProgressBar;
    Label11: TLabel;
    lPaquete: TLabel;
    Label12: TLabel;
    lEstadoConexion: TLabel;
    txtLog: TMemo;
    GroupBox3: TGroupBox;
    txtComentario: TMemo;
    GroupBox6: TGroupBox;
    lAplicacionNombre: TLabel;
    lAplicacionVersion: TLabel;
    Label10: TLabel;
    Label13: TLabel;
    Label18: TLabel;
    lNuevaVersion: TLabel;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Shape4: TShape;
    Shape5: TShape;
    Shape6: TShape;
    procedure BCerrarClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BActualizarClick(Sender: TObject);
    procedure zDescomFilePercentDone(Sender: TObject;
  Percent: Integer);
    procedure BComprobarClick(Sender: TObject);
    procedure BDesconectarClick(Sender: TObject);
    procedure LWEBClick2(Sender: TObject);
    procedure btOpcionesClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ftpDesConnected(Sender: TObject);
    procedure ftpDesDisconnected(Sender: TObject);
    procedure ftpDesStatus(axSender: TObject; const axStatus: TIdStatus;
      const asStatusText: String);
    procedure ftpDesWork(Sender: TObject; AWorkMode: TWorkMode;
      const AWorkCount: Integer);
  private
    { Private declarations }
  public
    nombreAplicacionActualizar : string;
    rutaAplicacionActualizar : string;
    versionAplicacionActualizar : string;
    utilizarfechaversion : string;
    comprimido : string;
    ejecutar : string;
    comprobarversion : string;
    ficheroFTP : string;
    ficheroLocal : string;
    claveRegistro : string;
//    mbRecibidos : double;
    { Public declarations }
  end;

var
  formMenuPrincipal: TformMenuPrincipal;

const
  claveEncriptacionTexto = 'aAdsxxXr45$d*dggd@sd';

implementation

{$R *.dfm}

//Comprueba si la aplicacin est ejecutndose ya
{function ejecutadaYa (nombreAplicacion : string) : boolean;
var
  MiMutex : Thandle;
begin
  mimutex := CreateMutex(nil, true, pchar(nombreAplicacion));
  if MiMutex = 0 then
    result := false
  else
  begin
    if GetLastError = ERROR_ALREADY_EXISTS then
      result := true
    else
      result := false;
  end;
end;}

//encriptar datos
function encriptar (Str, Clave : String) : String;
var
  Src: TStringStream;
  Dst: TMemoryStream;
  Size: Integer;
  Key: TAESKey;
  ExpandedKey: TAESExpandedKey;
begin
  Result := EmptyStr;
  Src := TStringStream.Create(Str);
  try
    Dst:= TMemoryStream.Create;
    try
      // Preparamos la clave, lo ideal es que tenga 32 caracteres
      FillChar(Key,Sizeof(Key),#0);
      if Length(Clave) > Sizeof(Key) then
        move(PChar(Clave)^,Key,Sizeof(key))
      else
        move(PChar(Clave)^,Key,Length(Clave));
      AEsExpandKey(ExpandedKey,Key);
      // Guardamos el tamao del texto original
      Size:= Src.Size;
      Dst.WriteBuffer(Size,Sizeof(Size));
      // Ciframos el texto
      AESEncryptStreamECB(Src,Dst,ExpandedKey);
      // Lo codificamos a base64
      Result:= BinToStr(Dst.Memory,Dst.Size);
    finally
      Dst.Free;
    end;
  finally
    Src.Free;
  end;
end;

//desencriptar datos
function desencriptar (Str, Clave : String): String;
var
  Src: TMemoryStream;
  Dst: TStringStream;
  Size: Integer;
  Key: TAESKey;
  ExpandedKey: TAESExpandedKey;
begin
  Result:= EmptyStr;
  Src:= TMemoryStream.Create;
  try
    Dst:= TStringStream.Create(Str);
    try
      StrToStream(Str, Src);
      Src.Position:= 0;
      FillChar(Key,Sizeof(Key),#0);
      if Length(Clave) > Sizeof(Key) then
        move(PChar(Clave)^,Key,Sizeof(key))
      else
        move(PChar(Clave)^,Key,Length(Clave));
      AESExpandKey(ExpandedKey,Key);
      // Leemos el tamao del texto
      try
        Src.ReadBuffer(Size,Sizeof(Size));
        AESDecryptStreamECB(Src,Dst,ExpandedKey);
        Dst.Size:= Size;
        Result:= Dst.DataString;
      except
        Result := '';
      end;
    finally
      Dst.Free;
    end;
  finally
    Src.Free;
  end;
end;

function convertirTextoFecha (texto : string) : TDate;
var
  caracterSeparador, cadTemp : string;
  posTmp : integer;
  dia, mes, ano : DWORD;
begin
  try
    if pos('-', texto) > 0  then
      caracterSeparador := '-'
    else
      caracterSeparador := '/';

    posTmp := pos(caracterSeparador, texto);
    dia := StrToInt(copy(texto, 1, posTmp - 1));

    cadTemp := copy(texto, posTmp + 1, length(texto));
    posTmp := pos(caracterSeparador, cadTemp);
    mes := StrToInt(copy(cadTemp, 1, posTmp - 1));

    cadTemp := copy(cadTemp, posTmp + 1, length(cadTemp));
    ano := StrToInt(cadTemp);

    Result := EncodeDate(ano, mes, dia);
  except
    result := null
  end;
end;

function reemplazarTexto (cadena, textoAReemplazar, textoNuevo : string) : string;
var
  aPos : Integer;
begin
  aPos := Pos(textoAReemplazar, Cadena);
  Result := '';
  while (aPos <> 0) do
  begin
    Result := Result + Copy(Cadena, 1, aPos - 1) + textoNuevo;
    Delete(Cadena, 1, aPos + Length(textoAReemplazar) - 1);
    aPos := Pos(textoAReemplazar, Cadena);
  end;
  Result := Result + Cadena;
end;



function extraerFechaCadena (cadena : string) : TDate;
var
  fechaEx : string;
begin
  try
    fechaEx := copy (cadena, pos(' ', cadena) + 1, length(cadena) - 1);
    fechaEx := reemplazarTexto(fechaEx, '(', '');
    fechaEx := reemplazarTexto(fechaEx, ')', '');
    fechaEx := reemplazarTexto(fechaEx, '[', '');
    fechaEx := reemplazarTexto(fechaEx, ']', '');

    Result := convertirTextoFecha(fechaEx);
  except
    result := null
  end;

end;

//Leer valor del Regedit
function leeRegistro (desdeClave : HKEY; ruta, cadena : string;
                      crear : boolean) : string;
var
  reg : TRegistry;
begin
  Reg := TRegistry.Create;
  try
    Reg.RootKey := desdeClave;
    Reg.OpenKey(ruta, crear);
    leeRegistro := Reg.ReadString(cadena);
  finally
    reg.Free;
  end;
end;


procedure TformMenuPrincipal.BCerrarClick(Sender: TObject);
begin
  ftpDes.Disconnect;
  close;
end;

procedure TformMenuPrincipal.FormShow(Sender: TObject);
begin
  if Not (FileExists(extractfilepath(application.exename) + 'configuracion.ini')) then
  begin
    MessageDlg('No se ha encontrado el fichero: "Configuracion.ini", necesario ' +
        'para actualizar la aplicacin. Para obtenerlo consulte con su ' +
        'administrador o bien configure manualmente las opciones ' +
        'de conexin y actualizacin.',
        mtWarning, [mbOK],0);
    BComprobar.Enabled := false;
    BActualizar.Enabled := false;
    BDesconectar.Enabled := false;
    lAplicacionNombre.Caption := 'No se ha indicado la aplicacin a actualizar';
    lAplicacionVersion.Caption := 'No disponible';
  end
  else
  begin
    with tinifile.create (extractfilepath(application.exename) + 'configuracion.ini') do
    try
      versionAplicacionActualizar := ReadString('Aplicacin', 'Versin', '');
      nombreAplicacionActualizar := ReadString('Aplicacin', 'Nombre', '');
      claveRegistro := ReadString('Aplicacin', 'Clave registro', '\SOFTWARE\AjpdSoft\');
      txtNombreAplicacion.Text := nombreAplicacionActualizar;
      txtVersion.Text := versionAplicacionActualizar;
      txtFicheroLocal.Text := ReadString('Aplicacin', 'Ruta', '');;
      txtClaveRegistro.Text := claveRegistro;

      txtCarpeta1.Text := ReadString('Ubicacin descarga', 'Carpeta1', '');
      txtCarpeta2.Text := ReadString('Ubicacin descarga', 'Carpeta2', '');
      txtCarpeta3.Text := ReadString('Ubicacin descarga', 'Carpeta3', '');
      txtCarpeta4.Text := ReadString('Ubicacin descarga', 'Carpeta4', '');
      ficheroFTP := ReadString('Ubicacin descarga', 'Fichero servidor', 'ajpdsoftinfo.ini');
      txtFichero.Text := ficheroFTP;

      txtUsuario.Text := ReadString('Conexin', 'Usuario', '');
      txtContrasena.Text := desencriptar (ReadString('Conexin', 'Contrasea', ''), claveEncriptacionTexto);
      txtServidor.Text := ReadString('Conexin', 'Servidor', '');
      txtPuerto.Text := ReadString('Conexin', 'Puerto', '21');
    finally
      free;
    end;

    //obtenemos la versin de la aplicacin instalada en el registro
    //de configuraciones de Windows
    versionAplicacionActualizar := leeRegistro (HKEY_CURRENT_USER,
        claveRegistro + nombreAplicacionActualizar, 'Versin', true);
    rutaAplicacionActualizar := leeRegistro (HKEY_CURRENT_USER,
        claveRegistro + nombreAplicacionActualizar, 'Ruta', true);

    //si no existe la versin en el registro, la cogemos del fichero .ini
    if versionAplicacionActualizar = '' then
      versionAplicacionActualizar := txtVersion.Text;
    if rutaAplicacionActualizar = '' then
      rutaAplicacionActualizar := txtFicheroLocal.Text
    else
      txtFicheroLocal.Text := rutaAplicacionActualizar;

    if nombreAplicacionActualizar <> '' then
      lAplicacionNombre.Caption := nombreAplicacionActualizar
    else
      lAplicacionNombre.Caption := 'No disponible';

    if versionAplicacionActualizar <> '' then
      lAplicacionVersion.Caption := versionAplicacionActualizar
    else
    begin
      lAplicacionVersion.Caption := 'No disponible';
      MessageDlg('No se ha encontrado la versin de la aplicacin local ' +
          '(ni en el registro ni en el fichero .ini). Debe indicar la ' +
          'versin para poder actualizar.', mtInformation, [mbok], 0);
    end;
  end;
end;

procedure TformMenuPrincipal.BActualizarClick(Sender: TObject);
var
  i, ficherosDescomprimidos : integer;
  hora, minuto, segundo, microsegundo, ano, mes, dia : Word;
  ficheroTemporalComprimido : string;
  tamanoFichServidor : integer;
begin
  lEstado.Caption := '';
  lEstado.Refresh;

  if MessageDlg('Es conveniente que realice una copia de seguridad de los ' +
      'datos antes de continuar con el proceso de actualizacin.',
      mtInformation, [mbok,mbcancel],0) = mrcancel then
    ftpDes.Disconnect
  else
  begin
    Screen.Cursor := crHourGlass;
    ficheroLocal := txtFicheroLocal.Text;

    //realizamos conexin al servidor FTP
    ftpDes.Disconnect;
    ftpDes.Host := txtServidor.Text;
    ftpDes.User := txtUsuario.Text;
    ftpDes.Password := txtContrasena.Text;
    if txtPuerto.Text <> '' then
      ftpDes.Port := StrToInt(txtPuerto.Text);
    lEstado.Caption := 'Conectando...';
    lEstado.Refresh;
    Refresh;
    try
      ftpDes.TransferType := ftBinary;
      ftpDes.Connect;

      if ftpDes.Connected then
      begin
        //nos movemos en el FTP a la carpeta y subcarpeta indicada
        if txtCarpeta1.Text <> '' then
        begin
          ftpDes.ChangeDir(txtCarpeta1.Text);
          lEstado.Caption := 'Abierta carpeta ' + txtCarpeta1.Text;
          lEstado.Refresh;
          Refresh;
        end;
        if txtCarpeta2.Text <> '' then
        begin
          ftpDes.ChangeDir(txtCarpeta2.Text);
          lEstado.Caption := 'Abierta carpeta ' + txtCarpeta3.Text;
          lEstado.Refresh;
          Refresh;
        end;
        if txtCarpeta3.Text <> '' then
        begin
          ftpDes.ChangeDir(txtCarpeta3.Text);
          lEstado.Caption := 'Abierta carpeta ' + txtCarpeta3.Text;
          lEstado.Refresh;
          Refresh;
        end;
        if txtCarpeta4.Text <> '' then
        begin
          ftpDes.ChangeDir(txtCarpeta4.Text);
          lEstado.Caption := 'Abierta carpeta ' + txtCarpeta4.Text;
          lEstado.Refresh;
          Refresh;
        end;

        lEstado.Caption := 'Descargando fichero ' + ficheroFTP;
        lEstado.Refresh;
        Refresh;
        if opDetalle.Checked then
        begin
          txtLog.Lines.Add ('Fichero local: ' + ficheroLocal);
          txtLog.Lines.Add ('Fichero FTP: ' + ficheroFTP);
        end;
        ficheroTemporalComprimido := IncludeTrailingPathDelimiter(ExtractFilePath(application.ExeName)) + 'temp00.zip';
        if FileExists(ficheroTemporalComprimido) then
        begin
          if not DeleteFile(ficheroTemporalComprimido) then
          begin
            lEstado.Caption := 'Error al eliminar fichero temporal';
            lEstado.Refresh;
            ftpDes.Disconnect;
            Screen.Cursor := crDefault;
            MessageDlg('No se ha podido eliminar el fichero temporal de descarga: ' +
                chr(13) + chr(13) + ficheroTemporalComprimido +
                chr(13) + chr(13) + 'Antes de poder realizar la actualizacin ' +
                'se debe eliminar este fichero.', mtWarning, [mbok], 0);
            Exit;                
          end;
        end;
        try
          tamanoFichServidor := ftpDes.Size(ficheroFTP);
          ftpDes.BeginWork(wmRead);
          bp.Min := 0;
          bp.Max := tamanoFichServidor;
          bp.Position := 0;
          bp.Refresh;

          ftpDes.Get (ficheroFTP, ficheroTemporalComprimido);
          ftpDes.EndWork(wmRead);
          ftpDes.Disconnect;
        except
          ftpDes.Disconnect;
          Screen.Cursor := crDefault;
          raise;
          exit;
        end;
        lEstado.Caption := 'Fichero de actualizacin descargado correctamente';
        lEstado.Refresh;
        if opDetalle.Checked then
          txtLog.Lines.Add (lEstado.Caption);
        Refresh;
        ficherosDescomprimidos := 0;
        //si est comprimido lo descomprimimos
        if comprimido = 'S' then
        begin
          if opDetalle.Checked then
            txtLog.Lines.Add ('Descomprimiendo Fichero local: ' + txtFicheroLocal.Text);
          zDescom.DestDir := ExtractFilePath(Application.ExeName);
          zDescom.RecreateDirs := false;
          lEstado.Caption := 'Descomprimiendo fichero';
          lEstado.Refresh;
          bp.Min := 0;
          bp.Max := 100;
          Refresh;
          zDescom.ZipName := ficheroTemporalComprimido;
          zDescom.ReadZip;
          for i := 0 to zDescom.Count - 1 do
          begin
            zDescom.Selected[i] := true;
          end;
          ficherosDescomprimidos := zDescom.UnZipSelected;
          if opDetalle.Checked then
            txtLog.Lines.Add ('Fin de descompresin Fichero local: ' + txtFicheroLocal.Text);
        end;

        if (comprimido = 'S') and (ficherosDescomprimidos <= 0) then
        begin
          Screen.Cursor := crDefault;
          ftpDes.Disconnect;
          lEstado.Caption := 'Error al descomprimir fichero';
          lEstado.Refresh;
          MessageDlg ('Ha habido errores al intentar descomprimir el fichero.',
              mtError, [mbok],0);
        end
        else
        begin
          if opDetalle.Checked then
            txtLog.Lines.Add ('Descompresin del fichero correcta.');
          try
            MkDir('Temp');
          except
            raise
          end;
          if opDetalle.Checked then
            txtLog.Lines.Add ('Ruta y nombre del fichero a actualizar: ' +
                rutaAplicacionActualizar + ExtractFileName(ficheroLocal));
          if FileExists(rutaAplicacionActualizar + ExtractFileName(ficheroLocal)) then
          begin
            DecodeTime(Time,hora,minuto,segundo,microsegundo);
            DecodeDate (date,ano,mes,dia);
            MoveFile(pchar(rutaAplicacionActualizar + ExtractFileName(ficheroLocal)),
               pchar(ExtractFilePath(Application.ExeName) + 'temp\' +
               copy(ExtractFileName(ficheroLocal),1,length(ExtractFileName(ficheroLocal)) - 4) +
               inttostr(mes) + '-' + inttostr(dia) + '-' + inttostr(ano)
               + '_' + inttostr(hora) + '-' + inttostr(minuto) + '-' +
               inttostr(segundo) + '-' + inttostr(microsegundo)));
          end;
          if FileExists(rutaAplicacionActualizar + ExtractFileName(ficheroLocal)) then
          begin
            ftpDes.Disconnect;
            Screen.Cursor := crDefault;
            lEstado.Caption := 'Error en la actualizacin';
            lEstado.Refresh;
            MessageDlg('La actualizacin no ha podido realizarse, debe cerrar la aplicacin ' +
                nombreAplicacionActualizar +
                ' y volver a intentarlo.', mtError, [mbok],0);
            exit;
          end;
          Application.ProcessMessages;
          if FileExists(ExtractFilePath(Application.ExeName) + ExtractFileName(ficheroLocal)) then
            MoveFile(pchar(ExtractFilePath(Application.ExeName) + ExtractFileName(ficheroLocal)),
               pchar(rutaAplicacionActualizar + ExtractFileName(ficheroLocal)))
          else
          begin
            ftpDes.Disconnect;
            Screen.Cursor := crDefault;
            lEstado.Caption := 'Error en la actualizacin';
            lEstado.Refresh;
            MessageDlg('La actualizacin no ha podido realizarse, ha habido errores. ' +
                ' Asegrese que la aplicacin que intenta actualizar est cerrada. ' +
                'Si el problema persiste consulte con su administrador de sistemas.',
                 mtError, [mbok],0);
            close;
            exit;
          end;
          ftpDes.Disconnect;
          BActualizar.Enabled := false;
          BDesconectar.Enabled := false;
          Screen.Cursor := crDefault;
          lEstado.Caption := 'Aplicacin ' + nombreAplicacionActualizar + ' actualizada correctamente';
          lEstado.Refresh;
          MessageDlg ('La actualizacin de la aplicacin ' +
              nombreAplicacionActualizar + ' ha finalizado correctamente.',
              mtInformation, [mbok],0);
        end;
      end
      else
      begin
        Screen.Cursor := crDefault;
        lEstado.Caption := 'Error en la conexin con el servidor FTP';
        lEstado.Refresh;
        MessageDlg('No se ha podido establecer conexin con el servidor FTP.',
            mtInformation, [mbok], 0);
      end;
    except
      ftpDes.Disconnect;
      Screen.Cursor := crDefault;
      raise
    end;
  end;
end;

procedure TformMenuPrincipal.zDescomFilePercentDone(Sender: TObject;
  Percent: Integer);
begin
  bp.Position := Percent;
  bp.Refresh;
  lEstado.Caption := 'Descomprimiendo fichero...';
  lEstado.Refresh;
end;

procedure TformMenuPrincipal.BComprobarClick(Sender: TObject);
type
  tversionF = array[1..4] of Integer;
  tversionL = array[1..4] of Integer;
var
  version, comentario, nombre, numeroVersionFTP, numeroVersionLocal, temporal : string;
  i, vp : integer;
  versionF : tversionF;
  versionL : tversionL;
  actualizar : boolean;
  ficheroConfiguracionLocal : string;
  tamanoFichServidor : integer;
  fechaVersionFTP, fechaVersionLocal : TDate;
begin
  lEstado.Caption := '';
  lNuevaVersion.Caption := '';
  lEstado.Refresh;
  if messagedlg('ATENCIN!!! ' + chr(13) +  chr(13) +
      '1. Debe cerrar la aplicacin ' +
      nombreAplicacionActualizar + ' antes de actualizarla.'
      + chr(13) +  chr(13) + '2. Debe estar conectado a Internet.' +  chr(13)
      +  chr(13) + '3. Es conveniente realizar una copia de seguridad'
      + ' de los datos antes de continuar.' +  chr(13) + chr(13) +
      chr(13) + '  NOTA: Si no realiza estos pasos la ' +
      'actualizacin no podr realizarse.',
      mtWarning, mbOKCancel,0) = mrcancel then
  begin
    exit;
  end;
  Screen.Cursor := crHourGlass;
  lEstado.Caption := 'Configurando conexin...';
  lEstado.Refresh;
  Refresh;

  ficheroFTP := txtFichero.Text;
  ficheroConfiguracionLocal := extractfilepath(application.exename) + ficheroFTP;

  if FileExists(ficheroConfiguracionLocal) then
  begin
    if not DeleteFile(ficheroConfiguracionLocal) then
    begin
      lEstado.Caption := 'Error al eliminar fichero temporal';
      lEstado.Refresh;
      MessageDlg('No se ha podido eliminar el fichero temporal de descarga: ' +
          chr(13) + chr(13) + ficheroConfiguracionLocal +
          chr(13) + chr(13) + 'Antes de poder realizar la actualizacin ' +
          'se debe eliminar este fichero.', mtWarning, [mbok], 0);
      ftpDes.Disconnect;
      Screen.Cursor := crDefault;
      Exit;
    end;
  end;

  //realizamos conexin al servidor FTP
  ftpDes.Disconnect;
  ftpDes.Host := txtServidor.Text;
  ftpDes.User := txtUsuario.Text;
  ftpDes.Password := txtContrasena.Text;
  if txtPuerto.Text <> '' then
    ftpDes.Port := StrToInt(txtPuerto.Text);
  lEstado.Caption := 'Conectando...';
  lEstado.Refresh;
  Refresh;
  try
    ftpDes.TransferType := ftBinary;
    ftpDes.Connect;

    //nos movemos en el FTP a la carpeta y subcarpeta indicada
    if txtCarpeta1.Text <> '' then
    begin
      ftpDes.ChangeDir(txtCarpeta1.Text);
      lEstado.Caption := 'Abierta carpeta ' + txtCarpeta1.Text;
      lEstado.Refresh;
      Refresh;
    end;
    if txtCarpeta2.Text <> '' then
    begin
      ftpDes.ChangeDir(txtCarpeta2.Text);
      lEstado.Caption := 'Abierta carpeta ' + txtCarpeta3.Text;
      lEstado.Refresh;
      Refresh;
    end;
    if txtCarpeta3.Text <> '' then
    begin
      ftpDes.ChangeDir(txtCarpeta3.Text);
      lEstado.Caption := 'Abierta carpeta ' + txtCarpeta3.Text;
      lEstado.Refresh;
      Refresh;
    end;
    if txtCarpeta4.Text <> '' then
    begin
      ftpDes.ChangeDir(txtCarpeta4.Text);
      lEstado.Caption := 'Abierta carpeta ' + txtCarpeta4.Text;
      lEstado.Refresh;
      Refresh;
    end;

    lEstado.Caption := 'Descargando fichero ' + ficheroFTP;
    lEstado.Refresh;
    Refresh;
    try
      tamanoFichServidor := ftpDes.Size(ficheroFTP);
      ftpDes.BeginWork(wmRead);
      bp.Min := 0;
      bp.Max := tamanoFichServidor;
      bp.Position := 0;
      bp.Refresh;
      ftpDes.Get(ficheroFTP, ficheroConfiguracionLocal);
      ftpDes.EndWork(wmRead);
      ftpDes.Disconnect;
      bp.Position := 0;
      bp.Refresh;
      lEstado.Caption := 'Fichero de comprobacin descargado correctamente';
      lEstado.Refresh;
      Refresh;

      //fichero informacin descargado del FTP
      with tinifile.create (ficheroConfiguracionLocal) do
      try
        version := ReadString('Aplicacin', 'Versin', '');
        comentario := ReadString('Aplicacin', 'Comentario', '');
        nombre := ReadString('Aplicacin', 'Nombre', '');
        comprimido := ReadString('Aplicacin', 'Comprimido', 'No');
        utilizarfechaversion := ReadString('Aplicacin', 'Utilizar fecha versin', 'No');
        ejecutar := ReadString('Aplicacin', 'Ejecutar despus de descarga', 'No');
        comprobarversion := ReadString('Aplicacin', 'Comprobar versin', 'No');
        ficheroFTP := ReadString('Aplicacin', 'Nombre fichero FTP', '');
        ficheroLocal := ReadString('Aplicacin', 'Nombre fichero local', '');
        lNuevaVersion.Caption := version;
        lNuevaVersion.Refresh;
      finally
        free;
      end;

      txtComentario.Clear;
      if (AnsiUpperCase (comprobarversion) = 'S') or
          (AnsiUpperCase (comprobarversion) = 'SI') or
          (AnsiUpperCase (comprobarversion) = 'S') then
      begin
        if nombre <> nombreAplicacionActualizar then
        begin
          Screen.Cursor := crDefault;
          lEstado.Caption := 'El nombre de la aplicacin local no coincide con el del FTP';
          lEstado.Refresh;
          MessageDlg('El nombre de la aplicacin local: ' + chr(13) + chr(13) +
              nombreAplicacionActualizar + chr(13) + chr(13) + 'No coincide con el de la ' +
              'aplicacin en el FTP para la actualizacin: ' + chr(13) + chr(13) + nombre +
              chr(13) + chr(13) + 'Consulte con su administrador.',
              mtWarning, [mbok],0);
          exit;
        end;
        txtComentario.Lines.Add(comentario);
        if version = versionAplicacionActualizar then
        begin
          Screen.Cursor := crDefault;
          MessageDlg('No se ha encontrado una nueva versin de ' +
              nombreAplicacionActualizar + '. Su versin est actualizada.' +
              chr(13) + chr(13) + ' * Versin actual local: ' + versionAplicacionActualizar +
              chr(13) + chr(13) + ' * Versin disponible en la web: ' + version,
              mtInformation, [mbok],0);
          exit;
        end;
        BActualizar.Enabled := true;

        //Comprobar versin por fecha
        if (AnsiUpperCase (utilizarfechaversion) = 'S') or
          (AnsiUpperCase (utilizarfechaversion) = 'SI') or
          (AnsiUpperCase (utilizarfechaversion) = 'S') then
        begin
          fechaVersionFTP := extraerFechaCadena(version);
          fechaVersionLocal := extraerFechaCadena(versionAplicacionActualizar);
          actualizar := fechaVersionFTP > fechaVersionLocal;
        end
        else
        begin
          //comprobar versin por nmeros
          numeroVersionFTP := trim (Copy (version, 0, Length(version) - pos('(',version)));
          numeroVersionLocal := trim (Copy (versionAplicacionActualizar, 0, Length(version) -  pos('(',version)));
          vp := 0;
          for i := 1 to Length(numeroVersionFTP) do
          begin
            if numeroVersionFTP[i] = '.' then
            begin
              vp := vp + 1;
              versionF[vp]:= strtoint(temporal);
              temporal := '';
            end
            else
              temporal := temporal + numeroVersionFTP[i];
          end;
          versionF[vp + 1] := strtoint(temporal);
          vp := 0;
          temporal := '';
          for i := 1 to Length(numeroVersionLocal) do
          begin
            if (numeroVersionLocal[i] = '.') then
            begin
              vp := vp + 1;
              versionL[vp] := strtoint(temporal);
              temporal := '';
            end
            else
              temporal := temporal + numeroVersionLocal[i];
          end;
          versionL[vp + 1] := strtoint(temporal);

          actualizar := false;
          if versionAplicacionActualizar = '' then
            actualizar := true
          else
          begin
            if versionF[1] > versionL[1] then
              actualizar := true;
            if (versionF[1] = versionL[1]) and (versionF[2] > versionL[2]) then
              actualizar := true;
            if (versionF[1] = versionL[1]) and (versionF[2] = versionL[2])
                and (versionF[3] > versionL[3]) then
              actualizar := true;
            if (versionF[1] = versionL[1]) and (versionF[2] = versionL[2])
                and (versionF[3] = versionL[3]) and (versionF[4] > versionL[4]) then
              actualizar := true;
          end;
        end;
      end
      else
      begin
        actualizar := true;
        BActualizar.Enabled := true;
      end;

      if actualizar then
      begin
        txtFicheroLocal.Text := ExtractFilePath (Application.ExeName) + ficheroLocal;
        BActualizar.Enabled := true;
        Screen.Cursor := crDefault;
        MessageDlg('Existe una nueva versin disponible: ' +
            version + '. Lea las mejoras y, si lo desea, pulse en "Actualizar" ' +
           'para actualizar la aplicacin con la nueva versin.',
           mtInformation, [mbok],0);
      end
      else
      begin
        Screen.Cursor := crDefault;
        MessageDlg('No se ha encontrado una nueva versin de ' +
          nombreAplicacionActualizar + '. Su versin est actualizada.' +
          chr(13) + chr(13) + ' * Versin actual local: ' + versionAplicacionActualizar +
          chr(13) + chr(13) + ' * Versin disponible en la web: ' + version,
          mtInformation, [mbok],0);
      end;

    except
      ftpDes.Disconnect;
      Screen.Cursor := crDefault;
      raise;
    end;
  except
    ftpDes.Disconnect;
    Screen.Cursor := crDefault;
    raise;
  end;
end;

procedure TformMenuPrincipal.BDesconectarClick(Sender: TObject);
begin
  Screen.Cursor := crDefault;
  ftpDes.Disconnect;
  lEstado.Caption := 'Desconectado';
  BActualizar.Enabled := false;
  BComprobar.Enabled := true;
end;

procedure TformMenuPrincipal.LWEBClick2(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar('http://www.ajpdsoft.com'),
      Nil, Nil, SW_SHOWNORMAL);
end;

procedure TformMenuPrincipal.btOpcionesClick(Sender: TObject);
begin
  if Height = 629 then
  begin
    btOpciones.Caption := 'Opciones >>';
    Height := 383;
  end
  else
  begin
    btOpciones.Caption := 'Opciones <<';
    Height := 629;
  end;
end;

procedure TformMenuPrincipal.FormCreate(Sender: TObject);
begin
  Height := 383;
end;

procedure TformMenuPrincipal.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  with tinifile.create (extractfilepath(application.exename) + 'configuracion.ini') do
  try
    WriteString('Aplicacin', 'Nombre', txtNombreAplicacion.Text);
    WriteString('Aplicacin', 'Versin', txtVersion.Text);
    WriteString('Aplicacin', 'Ruta', txtFicheroLocal.Text);
    WriteString('Aplicacin', 'Clave registro', txtClaveRegistro.Text);

    WriteString('Ubicacin descarga', 'Carpeta1', txtCarpeta1.Text);
    WriteString('Ubicacin descarga', 'Carpeta2', txtCarpeta2.Text);
    WriteString('Ubicacin descarga', 'Carpeta3', txtCarpeta3.Text);
    WriteString('Ubicacin descarga', 'Carpeta4', txtCarpeta4.Text);
    WriteString('Ubicacin descarga', 'Fichero servidor', txtFichero.Text);


    WriteString('Conexin', 'Usuario', txtUsuario.Text);
    WriteString('Conexin', 'Puerto', txtPuerto.Text);
    WriteString('Conexin', 'Servidor', txtServidor.Text);
    WriteString('Conexin', 'Contrasea', trim(encriptar (txtContrasena.Text, claveEncriptacionTexto)));
  finally
    free;
  end;
end;

procedure TformMenuPrincipal.ftpDesConnected(Sender: TObject);
begin
  BDesconectar.Enabled := true;
  lEstado.Caption := 'Se ha conectado satisfactoriamente al servidor...';
  lEstado.Refresh;
  if opDetalle.Checked then
    txtLog.Lines.Add(lEstado.Caption);
  Refresh;
end;

procedure TformMenuPrincipal.ftpDesDisconnected(Sender: TObject);
begin
  BDesconectar.Enabled := False;
  lEstado.Caption := 'Se ha desconectado del servidor...';
  lEstado.Refresh;
  if opDetalle.Checked then
    txtLog.Lines.Add(lEstado.Caption);
  Refresh;
end;

procedure TformMenuPrincipal.ftpDesStatus(axSender: TObject;
  const axStatus: TIdStatus; const asStatusText: String);
begin
  lEstadoConexion.Caption := asStatusText;
  lEstadoConexion.Refresh;
  if opDetalle.Checked then
    txtLog.Lines.Add(lEstado.Caption);
  Refresh;
end;

procedure TformMenuPrincipal.ftpDesWork(Sender: TObject;
  AWorkMode: TWorkMode; const AWorkCount: Integer);
begin
  bp.Position := AWorkCount;
  bp.Refresh;
  lPaquete.Caption := IntToStr(AWorkCount);
  lPaquete.Refresh;
  refresh;
end;

end.
